#!/usr/bin/env python
# -*- coding: utf-8 -*-

# This file contains names that have to be shared between different modules
# Turn this on or off for displaying the developing UI and activating experimental stuff...
develop = 0
intersectCommand = 0
globalScaleFactor = 0 # this activate and override a global tolerance for every hmCompound/hmOffset

# At the moment we should change too much the other scripts of interaction
multimesh = False # This activate the support for working with "multiple meshes" with the smart combine trick.



#========================================= Nodes names ====================================================
polySmoothName = 'hmPolySmooth'
intermediateMeshName = 'hmIntermediateMesh'

#========================================= Shaders ====================================================
shaderOptionVarName = 'hmShaderOptionVar'
darkPhong = 'hmDarkPhong'
reflectionShader = 'hmReflection'
zebraShader = 'hmZebra' #This can be very nice and easy to implement


#========================================= LAYERS ====================================================
#Layers names
origLayerName = 'hmOriginalMesh_lyr' #Utility layer for hiding input mesh
outLayerName = 'hmOutputMesh_lyr' #Utility layer for boolean meshes
curvesLayerName = 'hmCurves_lyr' #Utility layer for curves on meshes

#Layers color
origLayerColor = 10
outLayerColor = 12
curvesLayerColor = 15

#========================================= COLOR CHANGES ====================================================

activeCurvesColor = 13

#========================================= CONNECTIONS QUERY ====================================================
# These attributes are added to meshes and compound node, to keep track of 
# the connections, also if there are many more nodes in between

# ================= outMeshToCompound >>>> inMeshForCompoundA or B =================
#Orig mesh attr 
outMeshToCompound = 'hmMeshToCompound' #This will be added to the each original mesh to keep track of the connections with the compound

#Compound Attr #These two are added to the compound to keep track of the direct connection with the meshes
inMeshForCompoundA = 'hmMeshConnectionA' 
inMeshForCompoundB = 'hmMeshConnectionB'


# ================= outCompoundToMesh >>>> inMeshFromCompound =================
# This will keep track from compound to mesh 
outCompoundToMesh = 'hmCompoundOutToMesh' #This will be added to compound for outputting mesh

# This will always be connected to a compund as input (outCompoundToMesh)
inMeshFromCompound = 'hmMeshFromCompound' #This will be added to the result meshes


previewAndNextCompound = 'hmCompoundToCompound'


#========================================= OPERATION TYPES ====================================================
# These are the operations type allowed

operationA = 'Union' 
operationB = 'Difference A-B' 
operationC = 'Difference B-A' 
operationD = 'Intersection' 
operationE = 'Panel A-B' 
operationF = 'Panel B-A' 




#===============================================================================================================
#========================================= NODES ATTRIBUTES NAMES ====================================================
# Below this line, we store in variables the attributes names for the different nodes that we use		
#===============================================================================================================





#========================================= COMPOUND ATTRIBUTES NAMES ====================================================
#========= Conversion utility
#Filling strategy aliases  {'Standard':1, 'Equidistant':2, 'Experimental':3}
nodeFillStrategy = {7:1, 4:2, 10:3 }
uiFillStrategy = {1:7, 2:4, 3:10}


#Scene added attributes
operationType = 'opType'
offsetAttrName = 'hmOffset'
smoothAttrName = 'hmDivisions'

#Compound node standard attributes
geometryBias = 'geometryBias'
cornerBias = 'cornerBias'
sectionSpans = 'sectionSpans'

#Edge refinment
edgeSubd = 'refineMode'
edgeSubdA = 'Off'
edgeSubdB = 'Chord Dist'
edgeSubdC = 'Strict'
edgeSubdD = 'On Scale'

tolerance = 'tolerance'


fillStrategy = 'fillStrategy'
smoothFiller = 'smoothFiller'
# refinement = 'refinement' #Deprecated
weightA = 'weightA'
weightB = 'weightB'

activeRampedFiller = 'activeRampedFiller'
rampOffset = 'rampOffset'
rampScale = 'rampScale'
rampMode = 'rampMode' #Don't know if I'll use it
rampChordDist = 'rampChordDist' #The precision of the ramp tasselation
rampedFiller = 'rampedFiller' #The array profile curve

#Filler ramp attr
rampBaseId = 'rampedFiller'
rampPos = 'rampedFiller_Position' 
rampVal = 'rampedFiller_FloatValue'
rampInt = 'rampedFiller_Interp'

#Less important attr
autoMergeResult = 'autoMergeResult'
mergeDist = 'mergeDist'
computeNormals = 'computeNormals'

#Utility attr
operation = 'operation' #This invert the normals based on the performed operations

#========================================= OFFSET ATTRIBUTES NAMES ====================================================

offsetA = 'offsetA'
offsetB = 'offsetB'
booleanOperation = 'booleanOp'

#Options
removeCurl = 'removeCurl'
scaleFactor = 'scaleFactor'

#========================================= GENERIC ATTRIBUTES NAMES ====================================================

inMeshes = 'inMeshes'
inMeshesMatrix = 'inMeshesMatrix'
outMeshes = 'outMeshes'
outMeshesMatrix = 'outMeshesMatrix'
inCurves = 'inCurves'
inCurvesMatrix = 'inCurvesMatrix'
outCurves = 'outCurves'
outCurvesMatrix = 'outCurvesMatrix'



bindBias = 'bindingBias'
curveSequencer = 'curveSequencer'
sequenceBias = 'sequenceBias'



